package de.fraunhofer.iem.dataprovider.gitlab.controller

import de.fraunhofer.iem.dataprovider.configuration.ApiPaths
import de.fraunhofer.iem.dataprovider.gitlab.dto.RepositoryChangedRequestDto
import de.fraunhofer.iem.dataprovider.logger.getLogger
import de.fraunhofer.iem.dataprovider.toolRun.service.ToolRunService
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RestController

@RestController
class GitlabController(private val toolRunService: ToolRunService) {

    private val logger = getLogger(javaClass)

    @PostMapping(ApiPaths.OPENCODE_REPO_CHANGED)
    suspend fun repoChanged(@RequestBody repositoryChangedRequestDto: RepositoryChangedRequestDto) {
        logger.info("Repo changed POST request for ID ${repositoryChangedRequestDto.projectId} received.")
        toolRunService.createToolRunForRepository(repositoryChangedRequestDto.projectId)
    }
}
